#include <pthread.h>
#include <assert.h>

__declspec(dllimport) int init_library();

#define _thread_count 10
#define MyThread_get_thread_ident pthread_self

static pthread_t _threads[_thread_count];

static volatile int _teminated_thread_count = 0;

static void *thread_main(void *arg)
{
    sleep(1);

    ++_teminated_thread_count;
    printf("threaded ended %lx\n", MyThread_get_thread_ident());
}

#define USE_DETACH /* abort */

int main()
{
    int ret, i;

    init_library();

    for (i = 0; i < _thread_count; ++i)
    {
        ret = pthread_create(&_threads[i], NULL, thread_main, NULL);
	printf("Created thread %d %lx\n", i, _threads[i]);

        assert(ret == 0);

#ifdef USE_DETACH
        pthread_detach(_threads[i]);
#endif
    }

#ifdef USE_DETACH
    while (_teminated_thread_count < _thread_count)
    {
        sleep(1);
    }
#else
    for (i = 0; i < _thread_count; ++i)
    {
        ret = pthread_join(_threads[i], NULL);

        assert(ret == 0);
    }
#endif
}
